--- a/arch/mips/bcm63xx/boards/board_bcm963xx.c
+++ b/arch/mips/bcm63xx/boards/board_bcm963xx.c
@@ -1021,6 +1021,32 @@ static struct board_info __initdata boar
 		.force_duplex_full = 1,
 	},
 };
+
+static struct board_info __initdata board_96338w2_e7t = {
+	.name = "96338W2_E7T",
+	.expected_cpu_id = 0x6338,
+
+	.has_enet0 = 1,
+	.enet0 = {
+		.has_phy = 1,
+		.phy_id = 0,
+		.force_speed_100 = 1,
+		.force_duplex_full = 1,
+	},
+};
+
+static struct board_info __initdata board_rta1320_16m = {
+	.name = "RTA1320_16M",
+	.expected_cpu_id = 0x6338,
+
+	.has_enet0 = 1,
+	.enet0 = {
+		.has_phy = 1,
+		.phy_id = 0,
+		.force_speed_100 = 1,
+		.force_duplex_full = 1,
+	},
+};
 #endif /* CONFIG_BCM63XX_CPU_6338 */
 
 /*
@@ -1352,6 +1378,8 @@ static const struct board_info __initcon
 #ifdef CONFIG_BCM63XX_CPU_6338
 	&board_96338gw,
 	&board_96338w,
+	&board_96338w2_e7t,
+	&board_rta1320_16m,
 #endif /* CONFIG_BCM63XX_CPU_6338 */
 #ifdef CONFIG_BCM63XX_CPU_6345
 	&board_96345gw2,
@@ -1408,6 +1436,8 @@ static struct of_device_id const bcm963x
 #ifdef CONFIG_BCM63XX_CPU_6338
 	{ .compatible = "brcm,bcm96338gw", .data = &board_96338gw, },
 	{ .compatible = "brcm,bcm96338w", .data = &board_96338w, },
+	{ .compatible = "d-link,dsl-2640u", .data = &board_96338w2_e7t, },
+	{ .compatible = "dynalink,rta1320", .data = &board_rta1320_16m, },
 #endif /* CONFIG_BCM63XX_CPU_6338 */
 #ifdef CONFIG_BCM63XX_CPU_6345
 	{ .compatible = "brcm,bcm96345gw2", .data = &board_96345gw2, },
